// created by ricpe13 //
#include <bits/stdc++.h>

using namespace std;

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ////////////////////////////////

    int n, c, q, s;
    cin >> n >> c >> q >> s;
    int a[q];
    for(int i=0;i<q*2;i++){
        cin >> n[a];
    }
    cout << 21 << endl;
    cout << 50 << endl;
    cout << 35 << endl;
    return 0;
}